&routine nbuild

&define cover -1 &var
&define npcov -2 &var
&define addxy -3 &var
&define nptag -4 &var
&define covername -5 &var
&define npcovname -6 &var

&rem **** check parameters

&type " "
&goto usage &if &eq "x[cover]" "x"
&if &ncov [cover] &do
   &type "Coverage [cover] not found"
   &return
&end
&if &ninfo [cover].AAT &do
   &type "Coverage [cover] AAT not found"
   &return
&end
&if &cn [cover] \ &do
   &value [covername] [cover] %<lpos \ [cover] + 1>
&else
   &value [covername] [cover]
&end
&if &eq "x[npcov]" "x" &or &eq "x[npcov]" "x#" &do
   &sv [nptag] .FALSE.
&elseif &fn [npcov] &do
   &type "[npcov] already exists"
   &return
&else
   &if &cn [npcov] \ &do
      &value [npcovname] [npcov] %<lpos \ [npcov] + 1>
   &else
      &value [npcovname] [npcov]
   &end
   &sv [nptag] .TRUE.
&end
&extract [addxy] [addxy] 1
&if &eq "x[addxy]" "xADDXY" &do
   &sv [addxy] .TRUE.
&else
   &sv [addxy] .FALSE.
&end

&rem **** check for existing NAT

&if &info [cover].NAT &do
   & DEL [cover]\NAT.DBF
&end

&rem **** generate NODEPOINT coverage

&if &fn XX0001 &do
   DELETE XX0001 -NQ
&end
NODEPOINT [cover] XX0001
BUILD XX0001 POINT
&if &eq [nptag] .TRUE. &do
   COPY XX0001 [npcov]
   ADDITEM [npcov].PAT [npcov].PAT [covername]_ 11 11 N 0
&end
&if &eq [addxy] .TRUE. &do
   ADDXY XX0001
&end

&rem **** generate NAT

COPYINFO XX0001.PAT [cover].NAT
ADDITEM [cover].NAT [cover].NAT ARC_ 11 11 N 0 PERIMETER
&openw t$mod1.sml
&write "MODIFY XX0001_ [covername]_ 11 N 0"
&write "MODIFY XX0001_ID [covername]_ID 11 N 0"
&write "END"
&closew
MODITEM [cover].NAT t$mod1.sml
&openw t$pull1.sml
&write "ARC_"
&write "[covername]_"
&write "[covername]_ID"
&if &eq [addxy] .TRUE. &do
   &write "X_COORD"
   &write "Y_COORD"
&end
&write "END"
&write "Y"
&closew
PULLITEM [cover].NAT [cover].NAT t$pull1.sml

&rem **** generate ARC relate file

COPYINFO [cover].AAT XX0001.AAT
ADDITEM XX0001.AAT XX0001.AAT ARC_ 11 11 N 0

&rem **** build NAT internal attributes

&openw t$tab1.sml
&write "SEL XX0001.AAT"
&write "CALC ARC_ = [covername]_"
&write "CALC [covername]_ = TNODE_"
&write "SORT [covername]_"
&write "SEL [cover].NAT"
&write "CALC [covername]_ = [covername]_ID"
&write "SORT [covername]_"
&write "JOIN XX0001.AAT [covername]_"
&write "CALC ARC_ = #ARC_"
&write "JOIN OFF"
&write "RES ARC_ = 0"
&write "STATISTICS ARC_ # -1 -2 -3 -4 -5"
&write "&goto skip &if &eq %%-1 0"
&write "SEL XX0001.AAT"
&write "CALC [covername]_ = FNODE_"
&write "SORT [covername]_"
&write "SEL [cover].NAT"
&write "RES ARC_ = 0"
&write "JOIN XX0001.AAT [covername]_"
&write "CALC ARC_ = #ARC_"
&write "&label skip"
&if &eq [nptag] .TRUE. &do
   &write "SEL [npcov].PAT"
   &write "CALC [covername]_ = [npcovname]_ID"
&end
&write "Q"
&closew
TABLES t$tab1.sml

&rem **** clean up and exit

& DELETE XX0001 -NQ
& DEL t$*.sml
&return

&rem **** display usage

&label usage
&delim < >
&type "Usage: &r NBUILD [cover] {point_cover} {ADDXY}"
&delim [ ]
&return
